ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.4 by root, Wed Mar 7 20:30:18 2007 UTC vs.
Revision 1.57 by root, Mon Aug 20 22:09:04 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
18use IO::AIO (); 19use IO::AIO ();
19use File::Temp; 20use File::Temp;
20use Crossfire; 21use Crossfire;
21use Coro; 22use Coro;
22use Coro::AIO; 23use Coro::AIO;
24use Coro::Util;
23use POSIX (); 25use POSIX ();
26use Carp;
27use Coro::Channel;
28use Coro::Storable; $Storable::canonical = 1;
29
30$SIG{QUIT} = sub { Carp::cluck "QUIT" };
24 31
25sub usage { 32sub usage {
26 warn <<EOF; 33 warn <<EOF;
27Usage: cfutil [-v] [-q] [--force] [--cache] 34Usage: cfutil [-v] [-q] [--force] [--cache]
28 [--install-arch path] 35 [--install-arch path]
40my $CACHE = 0; 47my $CACHE = 0;
41my $FORCE; 48my $FORCE;
42my $TMPDIR = "/tmp/cfutil$$~"; 49my $TMPDIR = "/tmp/cfutil$$~";
43my $TMPFILE = "aaaa0"; 50my $TMPFILE = "aaaa0";
44 51
52our %COLOR = (
53 black => 0,
54 white => 1,
55 navy => 2,
56 red => 3,
57 orange => 4,
58 blue => 5,
59 darkorange => 6,
60 green => 7,
61 lightgreen => 8,
62 grey => 9,
63 brown => 10,
64 gold => 11,
65 tan => 12,
66);
67
45END { system "rm", "-rf", $TMPDIR } 68END { system "rm", "-rf", $TMPDIR }
46 69
47Event->signal (signal => "INT", cb => sub { exit 1 }); 70Event->signal (signal => "INT", cb => sub { exit 1 });
48Event->signal (signal => "TERM", cb => sub { exit 1 }); 71Event->signal (signal => "TERM", cb => sub { exit 1 });
49 72
66} 89}
67 90
68sub inst_maps($) { 91sub inst_maps($) {
69 my (undef, $path) = @_; 92 my (undef, $path) = @_;
70 93
71 print "installing '$path' to '$DATADIR/maps'\n\n"; 94 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
72 95
73 if (!-f "$path/regions") { 96 if (!-f "$path/regions") {
74 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 97 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
75 exit 1 unless $FORCE; 98 exit 1 unless $FORCE;
76 } 99 }
77 100
78 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 101 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
102 and die "map installation failed.\n";
103
104 print "maps installed successfully.\n";
79} 105}
80 106
81{ 107{
82 our @PNG; 108 our %ANIMINFO;
109 our %FACEINFO;
110 our %RESOURCE;
83 our @ARC; 111 our @ARC;
112 our %ARC;
113 our $TRS;
84 our $NFILE; 114 our $NFILE;
115 our $PATH;
85 116
86 our (@png, @trs, @arc); # files we are interested in 117 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
87 118
119 our $c_arc = new Coro::Channel;
120 our $c_trs = new Coro::Channel;
121 our $c_res = new Coro::Channel;
122
123 our @c_png;
124
88 sub commit_png { 125 sub commit_png($$$) {
89 my ($name, $data) = @_; 126 my ($name, $data, $T) = @_;
90 #warn "$name: commited\n"; 127
128 $FACEINFO{$name}{"data$T"} = $data;
91 } 129 }
92 130
93 sub process_png { 131 sub process_png {
94 while (@png) { 132 while (@c_png) {
95 my $path = pop @png; 133 my ($path, $delete) = @{pop @c_png};
96 134
97 my $png; 135 my $png;
98 aio_lstat $path; 136 aio_lstat $path;
99 my ($size, $mtime) = (stat _)[7,9]; 137 my ($size, $mtime) = (stat _)[7,9];
100 138
101 if (0 > aio_load $path, $png) { 139 if (0 > aio_load $path, $png) {
102 warn "$path: $!, skipping.\n"; 140 warn "$path: $!, skipping.\n";
103 return; 141 next;
104 } 142 }
105 143
144 my $stem = $path;
145 my $T;
146
147 if ($stem =~ s/\.32x32\.png~?$//) {
148 $T = 32;
149 } elsif ($stem =~ s/\.64x64\.png~?$//) {
150 $T = 64;
151 } else {
152 warn "$path: weird filename, skipping.\n";
153 next;
154 }
155
106 # quickly extratc width and height of the (necessarily PNG) image 156 # quickly extract width and height of the (necessarily PNG) image
107 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 157 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
108 warn "$path: not a recongized png file, skipping.\n"; 158 warn "$path: not a recognized png file, skipping.\n";
109 return; 159 next;
110 } 160 }
111 161
112 my ($w, $h) = unpack "NN", $1; 162 my ($w, $h) = unpack "NN", $1;
113
114 (my $face = $path) =~ s/^.*\///;
115 my $T = 32;
116
117 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
118 warn "$path: weird filename, skipping.\n";
119 return;
120 }
121 163
122 if ($w < $T || $h < $T) { 164 if ($w < $T || $h < $T) {
123 warn "$path: too small ($w $h), skipping.\n"; 165 warn "$path: too small ($w $h), skipping.\n";
124 return; 166 next;
125 } 167 }
126 168
127 if ($w % $T || $h % $T) { 169 if ($w % $T || $h % $T) {
128 warn "$path: weird png size ($w $h), skipping.\n"; 170 warn "$path: weird png size ($w $h), skipping.\n";
129 return; 171 next;
172 }
173
174 (my $base = $stem) =~ s/^.*\///;
175
176 my $fi = $FACEINFO{$base};
177 unless ($fi) {
178 warn "$path: <$base> not referenced by any archetype, skipping.\n";
179 next;
180 }
181
182 my $arc = $FACEINFO{$base}{arc}
183 or die "FATAL: internal error <$base>, cannot continue";
184
185 unless ($path =~ /~$/) {
186 # possibly enlarge
187 if (0 > aio_stat "$stem.64x64.png") {
188 my $other = "$stem.64x64.png~";
189
190 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
191 fork_sub {
192 my $CROP;
193 my $SRC = "png:\Q$path\E";
194
195 my $is_floor = $arc->{is_floor};
196 my $is_wall = 0;
197
198 my ($wall_pfx, $wall_dir, $wall_sfx);
199
200 if (
201 !$is_floor
202 && !$arc->{alive}
203 && $arc->{move_block} eq "all"
204 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
205 ) {
206 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
207
208 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
209 $is_wall = 1;
210 }
211 }
212
213 if ($is_wall || $is_floor) {
214 # add a 4px border and add other images around it
215 $CROP = "-shave 8x8 +repage";
216
217 $w += 8;
218 $h += 8;
219
220 $SRC = "-size ${w}x${h} xc:transparent";
221 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
222
223 # 8 surrounding images
224 for (
225 # x y b r0 r1
226 [-1, -1, 0, 6],
227 [ 0, -1, 1, 10, 14],
228 [+1, -1, 0, 12],
229
230 [-1, 0, 8, 5, 7],
231 #
232 [+1, 0, 2, 5, 13],
233
234 [-1, +1, 0, 3],
235 [ 0, +1, 4, 10, 11],
236 [+1, +1, 0, 9],
237 ) {
238 my ($x, $y, $d, $r0, $r1) = @$_;
239
240 my $tile = $is_floor ? $path
241 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
242 : die;
243
244 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
245 "\Q$tile",
246 $x * ($w - 8) + 4,
247 $y * ($h - 8) + 4;
248 }
249 }
250
251 system "convert -depth 8 $SRC rgba:-"
252 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
253 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
254 and die "convert/cfhq2xa pipeline error: status $? ($!)";
255 system $OPTIPNG, "-i0", "-q", "$other~";
256 die "$other~ has zero size, aborting." unless -s "$other~";
257 rename "$other~", $other;
258 };
259 }
260
261 push @c_png, [$other, !$CACHE];
130 } 262 }
131 263
264 # possibly scale down
265 if (0 > aio_stat "$stem.32x32.png") {
266 my $other = "$stem.32x32.png~";
267
268 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
269 fork_sub {
270 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
271 system $OPTIPNG, "-i0", "-q", "$other~";
272
273 # reduce smoothfaces >10000 bytes
274 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
275 my $ncolor = 256;
276 while () {
277 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
278 system $OPTIPNG, "-i0", "-q", "$other~~";
279 last if 10000 > -s "$other~~";
280 $ncolor = int $ncolor * 0.9;
281 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
282 }
283
284 printf "reduced %s from %d to %d bytes using %d colours.\n",
285 $other, -s "$other~", -s "$other~~", $ncolor
286 if $VERBOSE >= 2;
287 rename "$other~~", "$other~";
288 }
289
290 die "$other~ has zero size, aborting." unless -s "$other~";
291 rename "$other~", $other;
292 };
293 }
294
295 #warn "scaled down $path to $other\n";#d#
296 push @c_png, [$other, !$CACHE];
297 }
298 }
299
300 (my $face = $stem) =~ s/^.*\///;
301
302 # split all bigfaces, but avoid smoothfaces (*_S)
132 if (($w > $T || $h > $T) && $face !~ /_S\./) { 303 if (($w > $T || $h > $T) && $face !~ /_S\./) {
133 # split 304 # split
134 my @tile; 305 my @tile;
135 for my $x (0 .. (int $w / $T) - 1) { 306 for my $x (0 .. (int $w / $T) - 1) {
136 for my $y (0 .. (int $h / $T) - 1) { 307 for my $y (0 .. (int $h / $T) - 1) {
149 (map { 320 (map {
150 ( 321 (
151 "(", 322 "(",
152 "+clone", 323 "+clone",
153 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 324 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
325 "+repage",
326 -quality => "00",
154 -write => "png:$_->[2]~", 327 -write => "png32:$_->[2]~",
155 "+delete", 328 "+delete",
156 ")", 329 ")",
157 ) 330 )
158 } @todo), 331 } @todo),
159 "null:"; 332 "null:";
163 close $convert; 336 close $convert;
164 337
165 # pass 2, optimise, and rename 338 # pass 2, optimise, and rename
166 for (@todo) { 339 for (@todo) {
167 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 340 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
341 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
168 rename "$_->[2]~", $_->[2]; 342 rename "$_->[2]~", $_->[2];
169 } 343 }
170 }; 344 };
171 } 345 }
172 346
176 350
177 if (0 > aio_load $file, $tile) { 351 if (0 > aio_load $file, $tile) {
178 die "$path: unable to read tile +$x+$y, aborting.\n"; 352 die "$path: unable to read tile +$x+$y, aborting.\n";
179 } 353 }
180 IO::AIO::aio_unlink $file unless $CACHE; 354 IO::AIO::aio_unlink $file unless $CACHE;
181 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 355 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
182 } 356 }
183 } else { 357 } else {
184 # use as-is (either small, use smooth) 358 # use as-is (either small, use smooth)
185 commit_png $face, $png; 359 commit_png $face, $png, $T;
186 } 360 }
361
362 aio_unlink $path if $delete;
187 } 363 }
188 } 364 }
189 365
190 sub process_arc { 366 sub process_arc {
191 while (@arc) { 367 while (my $job = $c_arc->get) {
192 my ($dir, $file) = @{pop @arc}; 368 my ($dir, $file) = @$job;
193 369
194 my $arc; 370 my $arc;
195 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 371 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
196 372
197 my $arc = read_arch "$dir/$file"; 373 my $arc = read_arch "$dir/$file";
198 for my $o (values %$arc) { 374 for my $o (values %$arc) {
199 push @ARC, $o; 375 push @ARC, $o;
376 for (my $m = $o; $m; $m = $m->{more}) {
377 $ARC{$m->{_name}} = $m;
378 }
379
380 $o->{editor_folder} = $dir;
381
382 my $visibility = delete $o->{visibility};
383 my $magicmap = delete $o->{magicmap};
384
385 # find upper left corner :/
386 # omg, this is sooo broken
200 my ($dx, $dy); 387 my ($dx, $dy);
201 # omg, this is sooo broken
202 for (my $o = $o; $o; $o = $o->{more}) { 388 for (my $o = $o; $o; $o = $o->{more}) {
203 $dx = $o->{x} if $o->{x} < $dx; 389 $dx = $o->{x} if $o->{x} < $dx;
204 $dy = $o->{y} if $o->{y} < $dy; 390 $dy = $o->{y} if $o->{y} < $dy;
205 } 391 }
392
206 for (my $o = $o; $o; $o = $o->{more}) { 393 for (my $o = $o; $o; $o = $o->{more}) {
207 my $x = $o->{x} - $dx; 394 my $x = $o->{x} - $dx;
208 my $y = $o->{y} - $dy; 395 my $y = $o->{y} - $dy;
396
397 my $ext = $x|$y ? "+$x+$y" : "";
398
399 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
400
401 $visibility = delete $o->{visibility} if exists $o->{visibility};
402 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
403
404 my $anim = delete $o->{anim};
405
209 if ($x|$y) { 406 if ($anim) {
210 $_ .= "+$x+$y" for $o->{face}, @{$o->{anim} || []}; 407 # possibly add $ext to the animation name to avoid
408 # the need to specify archnames for all parts
409 # of a multipart archetype.
410 $o->{animation} = "$o->{_name}";
411 my $facings = 1;
412 my @frames;
413
414 for (@$anim) {
415 if (/^facings\s+(\d+)/) {
416 $facings = $1*1;
417 } elsif (/^blank.x11$|^empty.x11$/) {
418 push @frames, $_;
419 } else {
420 push @frames, "$_$ext";
421 }
422 }
423
424 $ANIMINFO{$o->{animation}} = {
425 facings => $facings,
426 frames => \@frames,
427 };
211 } 428 }
429
430 for my $face ($o->{face} || (), @{$anim || []}) {
431 next if $face =~ /^facings\s/;
432
433 my $info = $FACEINFO{$face} ||= { };
434 $info->{arc} = $o;
435
436 next if $face =~ /^blank.x11$|^empty.x11$/;
437
438 $info->{visibility} = $visibility if defined $visibility;
439 $info->{magicmap} = $magicmap if defined $magicmap;
440 }
441
442 if (my $smooth = delete $o->{smoothface}) {
443 my %kv = split /\s+/, $smooth;
444 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
445 while (my ($face, $smooth) = each %kv) {
446 $FACEINFO{$smooth}{arc} = $o;
447
448 $FACEINFO{$face}{smooth} = $smooth;
449 $FACEINFO{$face}{smoothlevel} = $level;
450 }
451 }
212 } 452 }
213 } 453 }
214 } 454 }
215 } 455 }
216 456
217 sub process_trs { 457 sub process_trs {
218 while (@trs) { 458 while (my $job = $c_trs->get) {
219 my ($dir, $file) = @{pop @trs}; 459 my ($dir, $file) = @$job;
460 my $path = "$dir/$file";
461
462 my $trs;
463 if (0 > aio_load $path, $trs) {
464 warn "$path: $!, skipping.\n";
465 next;
466 }
467
468 $TRS .= $trs;
469 }
470 }
471
472 my %FILECACHE;
473
474 sub load_cached($;$) {
475 unless (exists $FILECACHE{$_[0]}) {
476 my $data;
477 if (0 < aio_load $_[0], $data) {
478 if ($_[1]) {
479 $data = eval { $_[1]->($data) };
480 warn "$_[0]: $@" if $@;
481 }
482 }
483
484 $FILECACHE{$_[0]} = $data;
485 }
486
487 $FILECACHE{$_[0]}
488 }
489
490 sub process_res {
491 while (my $job = $c_res->get) {
492 my ($dir, $file, $type) = @$job;
493
494 my $data;
495 aio_load "$dir/$file", $data;
496
497 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
498
499 next if $meta && !exists $meta->{$file};
500
501 $meta = {
502 %{ $meta->{"" } || {} },
503 %{ $meta->{$file} || {} },
504 };
505
506 if ($meta->{license} =~ s/^#//) {
507 $meta->{license} = ({
508 "pd" => "Public Domain",
509 "gpl" => "GNU General Public License, version 3.0 or any later",
510 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
511 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
512 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
513 })->{$meta->{license}}
514 || warn "$dir/$file: license tag '$meta->{license}' not found.";
515 }
516
517 $file =~ s/\.res$//;
518 $file =~ s/\.(ogg|wav|jpg|png)$//;
519
520 substr $dir, 0, 1 + length $PATH, "";
521
522 $RESOURCE{"$dir/$file"} = {
523 type => (delete $meta->{type}) || $type,
524 data => $data,
525 %$meta ? (meta => $meta) : (),
526 };
220 } 527 }
221 } 528 }
222 529
223 sub find_files; 530 sub find_files;
224 sub find_files { 531 sub find_files {
229 my ($dirs, $nondirs) = @_; 536 my ($dirs, $nondirs) = @_;
230 537
231 find_files "$path/$_" 538 find_files "$path/$_"
232 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 539 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
233 540
541 my $dir = $path;
542 substr $dir, 0, 1 + length $PATH, "";
543
234 for my $file (@$nondirs) { 544 for my $file (@$nondirs) {
545 if ($dir =~ /^music(?:\/|$)/) {
546 $c_res->put ([$path, $file, 3]) # FT_MUSIC
547 if $file =~ /\.(ogg)$/;
548
549 } elsif ($dir =~ /^sound(?:\/|$)/) {
550 $c_res->put ([$path, $file, 5]) # FT_SOUND
551 if $file =~ /\.(wav|ogg)$/;
552
553 } elsif ($dir =~ /^res(?:\/|$)/) {
554 $c_res->put ([$path, $file, 0]) # FT_FACE
555 if $file =~ /\.(jpg|png)$/;
556 $c_res->put ([$path, $file, 7]) # FT_RSRC
557 if $file =~ /\.(res)$/;
558
235 if ($file =~ /\.png$/) { 559 } elsif ($file =~ /\.png$/) {
236 push @png, "$path/$file"; 560 push @c_png, ["$path/$file", 0];
561
237 } elsif ($file =~ /\.trs$/) { 562 } elsif ($file =~ /\.trs$/) {
238 push @trs, [$path, $file]; 563 $c_trs->put ([$path, $file]);
564
239 } elsif ($file =~ /\.arc$/) { 565 } elsif ($file =~ /\.arc$/) {
240 push @arc, [$path, $file]; 566 $c_arc->put ([$path, $file]);
567
241 } else { 568 } else {
242 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 569 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
243 } 570 }
244 } 571 }
245 }; 572 };
246 } 573 }
247 574
248 sub inst_arch($) { 575 sub inst_arch($) {
249 my (undef, $path) = @_; 576 my (undef, $path) = @_;
250 577
578 $PATH = $path;
579
580 print "\n",
251 print "installing '$path' to '$DATADIR'\n\n"; 581 "Installing '$path' to '$DATADIR'\n",
582 "\n",
583 "This can take a long time if you run this\n",
584 "for the first time or do not use --cache.\n",
585 "\n",
586 "Unless you run verbosely, all following warning\n",
587 "or error messages indicate serious problems.\n",
588 "\n";
252 589
253 if (!-d "$path/treasures") { 590 if (!-d "$path/treasures") {
254 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 591 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
255 exit 1 unless $FORCE; 592 exit 1 unless $FORCE;
256 } 593 }
257 594
595 print "scanning files...\n" if $VERBOSE;
596
258 find_files $path; 597 find_files $path;
598
599 my @a_arc = map +(async \&process_arc), 1..2;
600 my @a_res = map +(async \&process_res), 1..2;
601 my @a_trs = map +(async \&process_trs), 1..2;
602
259 IO::AIO::flush; 603 IO::AIO::flush;
260 604
261 $_->join for ( 605 $c_res->put (undef) for @a_res;
262 (async \&process_png), (async \&process_png), 606 $c_arc->put (undef) for @a_arc;
263 (async \&process_trs), (async \&process_trs), 607 $c_trs->put (undef) for @a_trs;
264 (async \&process_arc), (async \&process_arc), 608
609 print "start file scan, arc, res processing...\n" if $VERBOSE;
610
611 $_->join for @a_arc; # need to parse all archetypes before png processing
612
613 print "end arc, start png processing...\n" if $VERBOSE;
614
615 # four png crunchers work fine for my 2x smp machine
616 my @a_png = map +(async \&process_png), 1..4;
617
618 $_->join for (@a_trs, @a_res, @a_png);
619
620 print "scanning done, processing results...\n" if $VERBOSE;
265 ); 621 {
622 # remove path prefix from editor_folder
623 substr $_->{editor_folder}, 0, 1 + length $path, ""
624 for values %ARC;
266 625
626 print "resolving inheritance tree...\n" if $VERBOSE;
627 # resolve inherit
628 while () {
629 my $progress;
630 my $loop;
631
632 for my $o (values %ARC) {
633 if (my $other = $o->{inherit}) {
634 if (my $s = $ARC{$other}) {
635 if ($s->{inherit}) {
636 $loop = $s;
637 } else {
638 delete $o->{inherit};
639 my %s = %$s;
640 delete @s{qw(_name more name name_pl)};
641 %$o = ( %s, %$o );
642 ++$progress;
643 }
644 } else {
645 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
646 delete $ARC{$o->{_name}};
647 }
648 }
649 }
650
651 unless ($progress) {
652 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
653 if $loop;
654
655 last;
656 }
657 }
658
659 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
660 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
661
662 print "writing archetypes...\n" if $VERBOSE;
267 open my $archetypes, ">:utf8", "$DATADIR/archetypes~" 663 open my $fh, ">:utf8", "$DATADIR/archetypes~"
268 or die "$DATADIR/archetypes~: $!"; 664 or die "$DATADIR/archetypes~: $!";
269 print $archetypes Crossfire::archlist_to_string \@ARC; 665 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
270 close $archetypes; 666 }
271 rename "$DATADIR/archetypes~", "$DATADIR/archetypes";
272 667
273 die "--install-arch not fully implemented\n"; 668 {
669 print "writing treasures...\n" if $VERBOSE;
670 open my $fh, ">:utf8", "$DATADIR/treasures~"
671 or die "$DATADIR/treasures~: $!";
672 print $fh $TRS;
673 }
674
675 {
676 print "processing facedata...\n" if $VERBOSE;
677 while (my ($k, $v) = each %FACEINFO) {
678 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
679 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
680
681 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
682 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
683
684 if (my $magicmap = $v->{magicmap}) {
685 $magicmap =~ y/A-Z_\-/a-z/d;
686 $v->{magicmap} = $COLOR{$magicmap};
687 }
688
689 delete $v->{arc};
690 }
691
692 print "writing facedata...\n" if $VERBOSE;
693 open my $fh, ">:perlio", "$DATADIR/facedata~"
694 or die "$DATADIR/facedata~: $!";
695
696 print $fh freeze {
697 version => 2,
698 faceinfo => \%FACEINFO,
699 animinfo => \%ANIMINFO,
700 resource => \%RESOURCE,
701 };
702 }
703
704 print "committing files...\n" if $VERBOSE;
705
706 for (qw(archetypes facedata treasures)) {
707 chmod 0644, "$DATADIR/$_~";
708 rename "$DATADIR/$_~", "$DATADIR/$_"
709 or die "$DATADIR/$_: $!";
710 }
711
712 print "archetype data installed successfully.\n";
274 } 713 }
275} 714}
276 715
277Getopt::Long::Configure ("bundling", "no_ignore_case"); 716Getopt::Long::Configure ("bundling", "no_ignore_case");
278GetOptions ( 717GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines